#!/bin/sh

ADD1=106
ADD2=107

# directory where reside dlls to test
# can be a link
DIR=$PWD/dlls
if [ ! -d "$DIR" ]; then 
  echo dlls directory not found >&2
  exit 1
fi

rm -f vedi$ADD1.txt vedi$ADD2.txt error$ADD1.txt md5s$ADD1.txt
rm -f problems.diff
> problems.diff

# find all dll in this directory
FILES=`find "$DIR" -iname \*.dll -follow | sort`
NUM=`echo "$FILES" | wc -l | sed 's, ,,g'`
N=1
for file in $FILES
do

  echo "[$N/$NUM] $file"
  N=`expr $N + 1`
  echo "
----------------------------------------
File $file" >> error$ADD1.txt
#  ./perdr98d --show-priority -b "$file"  2>> /dev/null | perl -ne 'BEGIN { $show = 1 }; if ($_ =~ m,\^* Current priority: ,) { if ($_ =~ /filler|none/) { $show = 0} else { $show = 1 } }; print $_ if ($show)' > vedi1.txt
#  ./perdr --show-priority -b "$file"  2>> /dev/null | perl -ne 'BEGIN { $show = 1 }; if ($_ =~ m,\^* Current priority: ,) { if ($_ =~ /filler|none/) { $show = 0} else { $show = 1 } }; print $_ if ($show)' > vedi2.txt
#  ./corr.pl || echo "$file" >> lista.txt

#  wine ./perdr$ADD.exe $file 2>> error$ADD.txt | grep -v ^TimeDateStamp | grep -v "Possible string reference" | grep -v '^|\?$' | perl -pe 's,\r\n,\n,' > vedi$ADD.txt

  ./perdr$ADD1 -H -R --show-priority -b "$file"  2>> error$ADD1.txt | grep -v ^TimeStamp | perl -pe '
s/^Resources\n$//s;
s/(Addr:|hint:|Name:) +/$1/g;
s/\bID +(\d+)/ID $1/;
s/\b(DWORD|WORD|BYTE) /$1\t/;
s/([[+-])0+([0-9A-F]+h)\]/$1$2]/g;
s/Referenced by a \(U\)nconditional or \(C\)onditional Jump/Referenced by an (U)nconditional or (C)onditional Jump/;
s/^Version         (\d+):(\d+)/Version         $1.$2/;
' > vedi$ADD1.txt
  PID1=$!

./perdr$ADD2 -H --show-refs -R --show-priority -b "$file" 2>> /dev/null | grep -v ^TimeStamp | perl -pe '
s/(Addr:|hint:|Name:) +/$1/g;
s/\bID +(\d+)/ID $1/;
s/\b(DWORD|WORD|BYTE) /$1\t/;
s/([[+-])0+([0-9A-F]+h)\]/$1$2]/g;
s/\+0h]/]/;
s/\bLangID +(\d+) \(.*/LangID $1/;
' > vedi$ADD2.txt
  PID2=$!

  wait $PID1
  wait $PID2

  echo $file >> problems.diff
  diff -u vedi$ADD1.txt vedi$ADD2.txt >> problems.diff

#  ./perdr $file  2>> error$ADD.txt | grep -v '^ Addr:' > vedi.txt
  echo -n "$file " >> md5s$ADD1.txt
  md5sum vedi$ADD1.txt >> md5s$ADD1.txt
#  mv vedi.txt out/`echo $file | sed 's,.*/,,'`.txt
  rm -f vedi$ADD1.txt
done

cat md5s$ADD1.txt | sed "s,^$DIR/\\(.*\\.dll \\)\\([0-9a-f]\\+\\).*$,\\2 \\1,gi" > md5s2_$ADD1.txt
mv -f md5s2_$ADD1.txt md5s$ADD1.txt

perl error.pl error$ADD1.txt > vedi$ADD1.txt

less vedi$ADD1.txt

exit 0
